" Vim syntax file
" Language:     6502 Assembler
" Author:	Lars Stollenwerk
" Last Change:  2013-02-16

syntax clear

syn case match
syn keyword asmTodo TODO FIXME XXX contained
syn match asmSpecialComment "\\$" contained
syn match asmSpecialComment ":" contained

syn case ignore

syn match asmIdentifier "[a-z_][a-z0-9_]*"
syn match asmLabel      "^[a-z_][a-z0-9_]*"
syn match asmPseudoOp	"\.[a-z]\+"
syn match asmPreProc	"^#[a-z_].*"

syn match asmDecimal    "\d\+"
syn match asmHex	"\$\x\+"
syn region asmString    start=+"+ end=+"+

syn match asmComment    ";.*" contains=asmTodo,asmSpecialComment
syn match asmComment	"//.*" contains=asmTodo,asmSpecialComment
syn region asmComment	start="/\*" end="\*/" contains=asmTodo,asmSpecialComment


" OpCodes
syn keyword asmOpcode	adc and asl
syn keyword asmOpcode	bcc bcs beq bit bne bmi bpl brk bvc bvs
syn keyword asmOpcode	clc cld cli clv cmp cpx cpy
syn keyword asmOpcode	dec dex dey
syn keyword asmOpcode	eor
syn keyword asmOpcode	inc inx iny 
syn keyword asmOpcode	jmp jsr
syn keyword asmOpcode	lda ldx ldy lsr
syn keyword asmOpcode	nop
syn keyword asmOpcode	ora
syn keyword asmOpcode	pha php pla plp
syn keyword asmOpcode	rol ror rti rts
syn keyword asmOpcode	sbc sec sed sei sta stx sty
syn keyword asmOpcode	tax tay txa tya tsx txs

" C64 Kernal routines
syn case match
syn keyword asmKernal ACPTR CHKIN CHKOUT CHRIN CHROUT CIOUT CINT CLALL CLOSE
syn keyword asmKernal CLRCHN GETIN IOBASE IOINIT LISTEN LOAD MEMBOT MEMTOP
syn keyword asmKernal OPEN PLOT RDTIM READST RESTOR SAVE SCNKEY SCREEN SECOND
syn keyword asmKernal SETLFS SETMSG SETNAM SETTIM SETTMO STOP TALK TKSA UDTIM
syn keyword asmKernal UNLSN UNTLK VECTOR 


highlight link asmTodo  Todo
highlight link asmIdentifier Identifier
highlight link asmLabel Identifier
highlight link asmPseudoOp Statement
highlight link asmPreProc PreProc
highlight link asmDecimal Number
highlight link asmHex Number
highlight link asmComment Comment
highlight link asmString String
highlight link asmOpcode Statement
highlight link asmKernal Special
highlight link asmSpecialComment SpecialComment

